import 'bootstrap.css';
import '@grapecity/wijmo.styles/wijmo.css';
import './app.css';
//
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import * as wjGrid from '@grapecity/wijmo.react.grid';
import { ODataCollectionView } from '@grapecity/wijmo.odata';
import * as wjFilter from '@grapecity/wijmo.react.grid.filter';
class App extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            customers: new ODataCollectionView("https://services.odata.org/Northwind/Northwind.svc", "Customers", {
                sortOnServer: true,
                filterOnServer: true,
                loaded:(s)=>{this.dataLoaded(s)}
            }),
            itemCount: "",
            filter:null
        };
    }
    render() {
        return (<div className="container-fluid">
            <p>{this.state.itemCount}</p>
            <wjGrid.FlexGrid itemsSource={this.state.customers} isReadOnly={true} initialized={this.flexInitialized.bind(this)}>
                <wjFilter.FlexGridFilter initialized={s => { this.initializedFilter(s) }} filterApplied={s => { this.filterApplied(s) }} />
            </wjGrid.FlexGrid>
        </div>);
    }

    dataLoaded(s){
        console.log("beforeSetTimeOut==>",s);
        // setTimeout(() => {
            
        // }, 100);
        console.log("afterSetTimeOut==>",s);
            if(this.state.filter.filterDefinition !== localStorage['filterDefinition']) {
                this.state.filter.filterDefinition = localStorage['filterDefinition'];
            }
            console.log("Restoring filter: " + this.state.filter.filterDefinition);
        // console.log('setting filter definitions');
        // setTimeout(() => {
        //     if(localStorage['filterDefinition']) {
        //         console.log('filter definitions found');
        //         filter.filterDefinition = localStorage['filterDefinition'];
        //     }
        // })
        // console.log('filter definition set');
    }

    filterApplied(filter) {
        localStorage['filterDefinition'] = filter.filterDefinition;
        // console.log("Saving filter: " + filter.filterDefinition);
        // this.state.setState({
        //     filterReinitialized: false
        // });
    }

    initializedFilter(filter) {
        this.state.filter = filter;
        // console.log('setting filter definitions');
        // setTimeout(() => {
        //     if(localStorage['filterDefinition']) {
        //         console.log('filter definitions found');
        //         filter.filterDefinition = localStorage['filterDefinition'];
        //     }
        // })
        // console.log('filter definition set');
    }

    flexInitialized(flexgrid) {
        flexgrid.loadedRows.addHandler(() => {
            this.setState({
                itemCount: flexgrid.rows.length + " items"
            });
        });
    }
}
ReactDOM.render(<App />, document.getElementById("app"));
